<template>
  <div style="height: 600px;">
    <div style="display: flex; flex-direction: row; align-items: center; margin-top: 20px;">  
    <span style="margin-left: 10px;" class="demonstration">{{ $t('reportmanage.productiontime') }}</span>
    <el-date-picker style="margin-left: 10px;"  v-model="timeRange" type="daterange" format="YYYY/MM/DD" value-format="YYYY-MM-DD"
      :start-placeholder="$t('reportmanage.starttime')" :end-placeholder="$t('reportmanage.endtime')" :default-time="defaultTime" />
    <el-select v-model="report.type" :placeholder="$t('reportmanage.ctype')" style="margin-left: 10px;" >
      <el-option :label="$t('reportmanage.all')" value="0"></el-option>
      <el-option :label="$t('reportmanage.completed')" value="1"></el-option>
      <el-option :label="$t('reportmanage.broke')" value="2"></el-option>
      <el-option :label="$t('reportmanage.takeout')" value="3"></el-option>
    </el-select>
    <el-select v-model="report.status" :placeholder="$t('reportmanage.cstate')" style="margin-left: 10px;" >
      <el-option :label="$t('reportmanage.all')" value="0"></el-option>
      <el-option :label="$t('reportmanage.dreportwork')" value="1"></el-option>
      <el-option :label="$t('reportmanage.pendingwork')" value="2"></el-option>
      <el-option :label="$t('reportmanage.reportwork')" value="3"></el-option>
    </el-select>
    <el-select v-model="report.workingProcedure" :placeholder="$t('reportmanage.cprocess')" style="margin-left: 10px;" >
      <el-option :label="$t('reportmanage.all')" value="0"></el-option>
      <el-option :label="$t('reportmanage.incise')" value="切割"></el-option>
      <el-option :label="$t('reportmanage.edging')" value="磨边"></el-option>
      <el-option :label="$t('reportmanage.steel')" value="钢化"></el-option>
    </el-select>
    <el-button type="primary" style="margin-left: 10px;" @click="selectReportData()">{{ $t('reportmanage.inquire') }}</el-button>
    <el-button type="success" style="margin-left: 10px;" @click="handleConfirm">{{ $t('reportmanage.signingwork') }}</el-button>
  </div>
    <el-card style="flex: 1;margin-left: 10px;margin-top: 20px;" v-loading="loading">
      <div style="width: 98%; height: calc(100% - 35px); overflow-y: auto;">
    <el-table height="540" ref="table" :data="reportData"
      :header-cell-style="{ background: '#F2F3F5 ', color: '#1D2129' }">
      <el-table-column prop="teamsGroupsName" align="center" :label="$t('reportmanage.reporteam')" min-width="120" />
      <el-table-column prop="deviceName" align="center" :label="$t('reportmanage.reportingequipment')" min-width="120" />
      <el-table-column prop="line" align="center" :label="$t('reportmanage.line')" min-width="120" />
      <el-table-column prop="workingProcedure" align="center" :label="$t('reportmanage.process')" min-width="120" />
      <el-table-column prop="glassId" align="center" :label="$t('reportmanage.glassID')" min-width="130" />
      <el-table-column prop="engineerId" align="center" :label="$t('reportmanage.projectnumber')" min-width="120" />
      <el-table-column prop="temperingLayoutId" align="center" :label="$t('reportmanage.layoutID')" min-width="120" />
      <el-table-column prop="damageTime" align="center" :label="$t('reportmanage.productiontime')" min-width="230" />
      <el-table-column prop="type" align="center" :label="$t('reportmanage.type')" min-width="120" />
      <el-table-column prop="status" align="center" :label="$t('reportmanage.state')" min-width="120" />
      <el-table-column prop="processId" align="center" :label="$t('reportmanage.processcards')" min-width="140" />
      <el-table-column prop="orderNumber" align="center" :label="$t('reportmanage.number')" min-width="120" />
      <el-table-column prop="technologyNumber" align="center" :label="$t('reportmanage.layer')" min-width="120" />
      <el-table-column prop="breakageType" align="center" :label="$t('reportmanage.typebreakage')" min-width="180">
        <template #default="{ row }">  
        <el-select  
                      v-model="selectValuesa[row.id]"
                      filterable  
                      :placeholder="$t('reportmanage.pcausebreakage')"
                      clearable  
                      @input="handleInputChangea($event, row.id)"
                    >  
                 <el-option  
                    v-for="item in selectOptionsa"  
                    :key="item.basicName"  
                    :label="item.basicName"  
                    :value="item.basicName"  
                 />  
               </el-select>  
               </template>
      </el-table-column>
      <el-table-column prop="breakageReason" align="center" :label="$t('reportmanage.causebreakage')" min-width="180">
        <template #default="{ row }">  
        <el-select  
                      v-model="selectValuesb[row.id]"
                      filterable  
                      :placeholder="$t('reportmanage.ptypebreakage')"
                      clearable  
                      @input="handleInputChangea($event, row.id)"
                    >  
                 <el-option  
                    v-for="item in selectOptionsb"  
                    :key="item.basicName"  
                    :label="item.basicName"  
                    :value="item.basicName"  
                 />  
               </el-select>  
               </template>
      </el-table-column>
      <el-table-column align="center" :label="$t('reportmanage.responsibleprocess')" min-width="120">
        <template #default="{ row }">  
        <span>{{ '切割磨边钢化' }}</span>  
      </template>  
      </el-table-column>
      <el-table-column prop="responsiblePersonnel" align="center" :label="$t('reportmanage.responsiblepersonnel')" min-width="180">
        <template #default="{ row }">
          <el-input :placeholder="$t('reportmanage.presponsiblepersonnel')" v-model="inputValuesa[row.id]" autocomplete="off" />
        </template>
      </el-table-column>
      <el-table-column prop="responsibleTeam" align="center" :label="$t('reportmanage.responsibleteam')" min-width="180">
        <template #default="{ row }">  
        <el-select  
                      v-model="selectValuesc[row.id]"
                      filterable  
                      :placeholder="$t('reportmanage.presponsibleteam')"
                      clearable  
                      @input="handleInputChangea($event, row.id)"
                    >  
                 <el-option  
                    v-for="item in selectOptionsc"  
                    :key="item.basicName"  
                    :label="item.basicName"  
                    :value="item.basicName"  
                 />  
               </el-select>  
               </template>
      </el-table-column>
      <el-table-column prop="responsibleEquipment" align="center" :label="$t('reportmanage.responsibleequipment')" min-width="180">
        <template #default="{ row }">  
        <el-select  
                      v-model="selectValuesd[row.id]"
                      filterable  
                      :placeholder="$t('reportmanage.presponsibleequipment')"
                      clearable  
                      @input="handleInputChangea($event, row.id)"
                    >  
                 <el-option  
                    v-for="item in selectOptionsd"  
                    :key="item.basicName"  
                    :label="item.basicName"  
                    :value="item.basicName"  
                 />  
               </el-select>  
               </template>
      </el-table-column>
      <el-table-column prop="remark" align="center" :label="$t('reportmanage.remark')" min-width="180">
        <template #default="{ row }">
          <el-input :placeholder="$t('reportmanage.premark')" v-model="inputValuesb[row.id]" autocomplete="off" />
        </template>
      </el-table-column>
    </el-table>
    </div>
    </el-card>
  </div>
</template>
<script setup>
import { Delete, Upload } from '@element-plus/icons-vue'
import { ElMessage, ElMessageBox } from 'element-plus'
import { ref, onMounted, onBeforeUnmount, reactive, computed, shallowRef, onUnmounted, watchEffect } from "vue";
import request from "@/utils/request"
import { WebSocketHost, host } from '@/utils/constants'
import { initializeWebSocket, closeWebSocket } from '@/utils/WebSocketService';
import { useI18n } from 'vue-i18n'
const { t } = useI18n()
const report = ref({
  type: '0',
  status: '0',
  workingProcedure: '0',
});
const reportData = ref([])
const timeRange = ref(["2022-01-01", "2025-01-01"])
const selectOptionsa = ref([]);
const selectOptionsb = ref([]);
const selectOptionsc = ref([]);
const selectOptionsd = ref([]);
const selectValuesa = reactive({});
const selectValuesb = reactive({});
const selectValuesc = reactive({});
const selectValuesd = reactive({});
const inputValuesa = reactive({});
const inputValuesb = reactive({});


// 查询数据
const selectReportData = async () => {
  const response = await request.post("/cacheVerticalGlass/damage/selectDamage", {
    startTime: timeRange.value[0],
    endTime: timeRange.value[1],
    type: report.value.type,
    status: report.value.status,
    workingProcedure: report.value.workingProcedure
  })
  if (response.code === 200) {
    reportData.value = response.data;
    ElMessage.success(response.message);
  } else {
    ElMessage.error(response.message);
  }

  // const responses = await request.post("/cacheVerticalGlass/damage/insertDamage", {
  //   glassId:"P24081502|1|1",
  //   line:"1001",
  //   workingProcedure:"切割",
  //   remark:"",
  //   status:"0"
  // })
};
// 报工
const handleConfirm = async () => {
  const response = await request.post("/cacheVerticalGlass/damage/submitDamage", reportData.value)
  if (response.code === 200) {
    ElMessage.success(response.message);
  } else {
    ElMessage.error(response.message);
  }
};
const fetchTableData = async () => {  
  try {  
    const response = await request.post('/cacheVerticalGlass/basic_data_produce/selectBasicDataProduceGroup');  
    if (response.code == 200) {  
      selectOptionsa.value = response.data.breakagetype.filter(item => item !== null)
.map(item => ({ basicName: item.basicName }));
      selectOptionsb.value = response.data.breakagereason.filter(item => item !== null)
.map(item => ({ basicName: item.basicName }));
      selectOptionsc.value = response.data.teamsgroups.filter(item => item !== null)
.map(item => ({ basicName: item.basicName }));
      selectOptionsd.value = response.data.device.filter(item => item !== null)
.map(item => ({ basicName: item.basicName }));
    } else {  
      ElMessage.warning(response.data);  
    }  
  } catch (error) {  
    console.error('Error fetching options:', error);  
  }  
}; 
const handleInputChangea = (value, rowId) => {  
  // 更新对应行的 select 值  
  selectValuesa[rowId] = value;  
  selectValuesb[rowId] = value;  
  selectValuesc[rowId] = value;  
  selectValuesd[rowId] = value;  
  inputValuesa[rowId] = value;  
  inputValuesb[rowId] = value;  
};
fetchTableData();  
let socket = null;
// const socketUrl = `ws://${WebSocketHost}:${host}/api/temperingGlass/api/talk/screen`;
// const handleMessage = (data) => {
  // adjustedRects.value = data.device[0].map(rect => ({  
  //       ...rect, 
  //       completed: rect.completedQuantity,
  //       breakage: rect.breakageQuantity,
  //       thisProcess: rect.thisProcess,
  //     })); 
// };
// let socket;
onMounted(() => {
  // socket = new WebSocket(socketUrl);
  // socket.onmessage = (event) => {
  //   const data = JSON.parse(event.data);

  //   // updateCharts();
  // };
  // };  
});
onUnmounted(() => {
  socket.close();
});
onMounted(() => {
  fetchTableData();
  // socket = initializeWebSocket(socketUrl, handleMessage);
});
  onUnmounted(() => {
    if (socket) {
    closeWebSocket(socket);
    }
    });
onBeforeUnmount(() => {
  console.log("关闭了")
  closeWebSocket();
});
</script>

<style scoped></style>